Index: blockerbugs/cli.py
===================================================================
--- blockerbugs/cli.py
+++ blockerbugs/cli.py
@@ -100,7 +100,7 @@
         db.session.commit()
 
 
-def generate_config(dburi=None, bugzilla_cookie=None):
+def generate_config(dburi=None):
     config_filename = os.path.abspath('conf/settings.py')
     if os.path.exists(config_filename):
         print "configuration file %s already exists, exiting" % config_filename
@@ -119,10 +119,6 @@
     config_file.write('FAS_ADMIN_GROUP = \'\'\n')
     config_file.write('FAS_USER = \'\'\n')
     config_file.write('FAS_PASSWORD = \'\'\n')
-    if bugzilla_cookie:
-        config_file.write('BUGZILLA_COOKIE = \'%s\'\n' % str(bugzilla_cookie))
-    else:
-        config_file.write('BUGZILLA_COOKIE = None\n')
     config_file.close()
 
 
@@ -196,8 +192,6 @@
     parser.add_option('-b', '--blocker', dest='blocker',
                       help='blocker tracking bug id')
     parser.add_option('-a', '--accepted', dest='fe', help='FE tracking bug id')
-    parser.add_option('-z', '--bzcookie', dest='bzcookie', default=None,
-                      help='location of bugzilla cookie file to use')
 
     (options, args) = parser.parse_args()
 
@@ -228,7 +222,7 @@
     elif command == 'add_release':
         add_release(options.release)
     elif command == 'generate_config':
-        generate_config(dburi=options.dburi, bugzilla_cookie=options.bzcookie)
+        generate_config(dburi=options.dburi)
     elif command == 'minify':
         minify()
 
Index: blockerbugs/config.py
===================================================================
--- blockerbugs/config.py
+++ blockerbugs/config.py
@@ -31,7 +31,6 @@
     FAS_HTTPS_REQUIRED = False
     FAS_CHECK_CERT = False
     FAS_BASE_URL = 'https://admin.stg.fedoraproject.org/accounts/'
-    BUGZILLA_COOKIE = '.bugzillacookies'
     LOGFILE = '/var/log/blockerbugs/blockerbugs.log'
     FILE_LOGGING = False
     SYSLOG_LOGGING = False
@@ -43,7 +42,6 @@
     DEBUG = False
     BUGZILLA_URL = 'https://bugzilla.redhat.com/'
     BUGZILLA_XMLRPC = BUGZILLA_URL + 'xmlrpc.cgi'
-    BUGZILLA_COOKIE = '/var/www/blockerbugs/bugzillacookie'
     KOJI_URL = 'http://koji.fedoraproject.org/'
     FAS_HTTPS_REQUIRED = True
     FAS_BASE_URL = 'https://admin.fedoraproject.org/accounts/'
Index: blockerbugs/controllers/main.py
===================================================================
--- blockerbugs/controllers/main.py
+++ blockerbugs/controllers/main.py
@@ -307,13 +307,13 @@
 
             app.logger.debug('logging into bugzilla (%s) as %s' % (app.config['BUGZILLA_XMLRPC'], app.config['FAS_USER']))
 
-            return bugzilla.RHBugzilla4(url = app.config['BUGZILLA_XMLRPC'],
-                                        user = app.config['FAS_USER'],
-                                        password = app.config['FAS_PASSWORD'],
-                                        cookiefile = None)
+            return bugzilla.RHBugzilla4(url=app.config['BUGZILLA_XMLRPC'],
+                                        user=app.config['FAS_USER'],
+                                        password=app.config['FAS_PASSWORD'],
+                                        cookiefile=None)
         else:
             app.logger.warning('No FAS_USER configured. bugzilla modifications will NOT work!')
-            return bugzilla.RHBugzilla4(url=app.config['BUGZILLA_XMLRPC'])
+            return bugzilla.RHBugzilla4(url=app.config['BUGZILLA_XMLRPC'], cookiefile=None)
     else:
         app.logger.error('Bugzilla connections with test configuration is not supported!')
         return None
Index: blockerbugs/util/bz_interface.py
===================================================================
--- blockerbugs/util/bz_interface.py
+++ blockerbugs/util/bz_interface.py
@@ -46,11 +46,12 @@
             if not url:
                 url = 'https://bugzilla.redhat.com/xmlrpc.cgi'
             if not (user and password):
-                self.bz = bugzilla.RHBugzilla4(url=url)
+                self.bz = bugzilla.RHBugzilla4(url=url, cookiefile=None)
             else:
                 self.bz = bugzilla.RHBugzilla4(url=url,
                                                user=user,
-                                               password=password)
+                                               password=password,
+                                               cookiefile=None)
         else:
             self.bz = bz
         self.logger.info('Using bugzilla URL: %s' % url)
Index: docs/source/blockerbugscli.rst
===================================================================
--- docs/source/blockerbugscli.rst
+++ docs/source/blockerbugscli.rst
@@ -109,10 +109,4 @@
 
 The FE tracking bugid for a milestone
 
--z, --bzcookie
-^^^^^^^^^^^^^^
-
-Location of bugzilla cookie to use. This should not be used outside of development
-environments as it causes problems when used with a non-regular user account.
-
 