Index: libtaskotron/koji_utils.py
===================================================================
--- libtaskotron/koji_utils.py
+++ libtaskotron/koji_utils.py
@@ -12,45 +12,47 @@
 from libtaskotron.logger import log
 from libtaskotron import exceptions as exc
 from libtaskotron import rpm_utils
+from libtaskotron import config
 
-KOJI_URL = 'http://koji.fedoraproject.org/kojihub'
-PKG_URL = 'http://kojipkgs.fedoraproject.org/packages'
 
 class KojiClient(object):
-    def __init__(self, koji_session=None):
-        self.session = koji_session
+    '''Helper Koji methods.
 
-    def get_koji_session(self):
-        if self.session is None:
-            self.session = koji.ClientSession(KOJI_URL)
+    Note: You can access the standard Koji client (from @module koji) as
+    self.session.
+    '''
+    def __init__(self, koji_session=None):
+        '''Create a new KojiClient
+        @param koji_session an existing Koji session (koji.ClientSession),
+                            or None if you want a new default session to be
+                            created
+        '''
+        self.session = (koji_session or
+            koji.ClientSession(config.get_config().koji_url))
 
-        return self.session
 
     def nvr_to_urls(self, nvr, arches=None, debuginfo=False, src=True):
         '''Get list of URLs for RPMs corresponding to a build.
         @param nvr build NVR
         @param arches restrict the arches of builds to provide URLs for. If
                         basearch i386 is in the list, i686 arch is automatically
                         added (since that's the arch Koji API uses).
         '''
-
         log.info('Querying Koji for a list of RPMS for: %s', nvr)
 
-        ksession = self.get_koji_session()
-
         # add i686 arch if i386 is present in arches
         if arches and 'i386' in arches and 'i686' not in arches:
             arches.append('i686')
 
-        info = ksession.getBuild(nvr)
+        info = self.session.getBuild(nvr)
         if info is None:
             raise exc.TaskotronRemoteError(
                 "No build information found for %s" % nvr)
 
-        baseurl = '/'.join((PKG_URL, info['package_name'],
+        baseurl = '/'.join((config.get_config().pkg_url, info['package_name'],
                             info['version'], info['release']))
 
-        rpms = ksession.listRPMs(buildID=info['id'], arches=arches)
+        rpms = self.session.listRPMs(buildID=info['id'], arches=arches)
         if not debuginfo:
             rpms = [r for r in rpms if not r['name'].endswith('-debuginfo')]
         if not src:
@@ -62,6 +64,7 @@
 
         return sorted(urls)
 
+
     def get_nvr_rpms(self, nvr, rpm_dir, arches=None, debuginfo=False,
                      src=False):
         '''Retrieve the RPMs associated with a build NVR into the specified
@@ -72,12 +75,10 @@
         @return list of local filenames of the grabbed RPMs
         @raise TaskotronRemoteError if downloading failed
         '''
-
         rpm_urls = self.nvr_to_urls(nvr,
                                     arches=arches,
                                     debuginfo=debuginfo,
                                     src=src)
-
         rpm_files = []
         log.info('Fetching RPMs for: %s', nvr)
         for url in rpm_urls:
@@ -87,20 +88,19 @@
 
         return rpm_files
 
+
     def get_tagged_rpms(self, tag, dest, arches):
         '''Downloads all RPMs of all NVRs tagged by a specific Koji tag.
         @dest destination directory
         @arches list of architectures
         @raise TaskotronRemoteError if downloading failed
         '''
-        ksession = self.get_koji_session()
-        opts = {}
-        tag_data = ksession.listTagged(tag, **opts)
-
+        tag_data = self.session.listTagged(tag)
         nvrs = ["%(nvr)s" % x for x in tag_data]
         rpms = []
         for nvr in nvrs:
             rpms.append(self.get_nvr_rpms(nvr, dest, arches))
+
         return rpms
 
 
Index: testing/test_koji_utils.py
===================================================================
--- testing/test_koji_utils.py
+++ testing/test_koji_utils.py
@@ -9,6 +9,7 @@
 
 from libtaskotron import koji_utils
 from libtaskotron import exceptions as exc
+from libtaskotron import config
 
 class TestKojiClient():
     def setup_method(self, method):
@@ -31,19 +32,15 @@
                      'release': self.ref_release, 'nvr': self.ref_nvr,
                      'arch': 'src'}]
 
-        self.ref_url = 'http://downloads.example.com/builds/%s.noarch.rpm' \
-                       % self.ref_nvr
-        self.helper = koji_utils.KojiClient()
-
     def test_get_noarch_rpmurls_from_nvr(self):
         stub_koji = Dingus(getBuild__returns = self.ref_build,
                            listRPMs__returns = self.ref_rpms)
 
         test_koji = koji_utils.KojiClient(stub_koji)
 
         test_urls = test_koji.nvr_to_urls(self.ref_nvr)
 
-        koji_baseurl = koji_utils.PKG_URL
+        koji_baseurl = config.get_config().pkg_url
         ref_urls = ['%s/%s/%s/%s/%s/%s.%s.rpm' % (koji_baseurl, self.ref_name,
                         self.ref_version, self.ref_release, self.ref_arch,
                         self.ref_nvr, self.ref_arch),